Loading...
Searching...
No Matches
juce::dsp Namespace Reference

## Namespaces

namespace | util
namespace | DelayLineInterpolationTypes
| A collection of structs to pass as the template argument when setting the interpolation type for the DelayLine class.
namespace | FIR
| Classes for FIR filter processing.
namespace | IIR
| Classes for IIR filter processing.
namespace | StateVariableFilter
| Classes for state variable filter processing.

## Classes

class | AudioBlock
| Minimal and lightweight data-structure which contains a list of pointers to channels containing some kind of sample data. More...
struct | SIMDRegister
| A wrapper around the platform's native SIMD register type. More...
struct | FilterDesign
| This class provides a set of functions which generates FIR::Coefficients and IIR::Coefficients, of high-order low-pass filters. More...
class | ConvolutionMessageQueue
| Used by the Convolution to dispatch engine-update messages on a background thread. More...
class | Convolution
| Performs stereo partitioned convolution of an input signal with an impulse response in the frequency domain, using the JUCE FFT class. More...
class | FFT
| Performs a fast fourier transform. More...
class | WindowingFunction
| A class which provides multiple windowing functions useful for filter design and spectrum analyzers. More...
struct | FastMathApproximations
| This class contains various fast mathematical function approximations. More...
class | LogRampedValue
| Utility class for logarithmically smoothed linear values. More...
class | LookupTable
| Class for efficiently approximating expensive arithmetic operations. More...
class | LookupTableTransform
| Class for approximating expensive arithmetic operations. More...
class | Matrix
| General matrix and vectors class, meant for classic math manipulation such as additions, multiplications, and linear systems of equations solving. More...
struct | Phase
| Represents an increasing phase value between 0 and 2*pi. More...
class | Polynomial
| A class representing a polynomial. More...
struct | SpecialFunctions
| Contains miscellaneous filter design and windowing functions. More...
class | BallisticsFilter
| A processor to apply standard attack / release ballistics to an input signal. More...
class | DelayLine
| A delay line processor featuring several algorithms for the fractional delay calculation, block processing, and sample-by-sample processing useful when modulating the delay in real time or creating a standard delay effect with feedback. More...
class | DryWetMixer
| A processor to handle dry/wet mixing of two audio signals, where the wet signal may have additional latency. More...
class | FirstOrderTPTFilter
| A first order filter class using the TPT (Topology-Preserving Transform) structure. More...
class | LinkwitzRileyFilter
| A filter class designed to perform multi-band separation using the TPT (Topology-Preserving Transform) structure. More...
class | Oversampling
| A processor that performs multi-channel oversampling. More...
class | Panner
| A processor to perform panning operations on stereo buffers. More...
struct | ProcessSpec
| This structure is passed into a DSP algorithm's prepare() method, and contains information about various aspects of the context in which it can expect to be called. More...
struct | ProcessorState
| This is a handy base class for the state of a processor (such as parameter values) which is typically shared among several processors. More...
struct | ProcessContextReplacing
| Contains context information that is passed into an algorithm's process method. More...
struct | ProcessContextNonReplacing
| Contains context information that is passed into an algorithm's process method. More...
class | ProcessorChain
| This variadically-templated class lets you join together any number of processor classes into a single processor which will call process() on them all in sequence. More...
struct | ProcessorDuplicator
| Converts a mono processor class into a multi-channel version by duplicating it and applying multichannel buffers across an array of instances. More...
struct | ProcessorBase
| Acts as a polymorphic base class for processors. More...
struct | ProcessorWrapper
| Wraps an instance of a given processor class, and exposes it through the ProcessorBase interface. More...
class | StateVariableTPTFilter
| An IIR filter that can perform low, band and high-pass filtering on an audio signal, with 12 dB of attenuation per octave, using a TPT structure, designed for fast modulation (see Vadim Zavalishin's documentation about TPT structures for more information). More...
class | Bias
| Adds a DC offset (voltage bias) to the audio samples. More...
class | Chorus
| A simple chorus DSP widget that modulates the delay of a delay line in order to create sweeping notches in the magnitude frequency response. More...
class | Compressor
| A simple compressor with standard threshold, ratio, attack time and release time controls. More...
class | Gain
| Applies a gain to audio samples as single samples or AudioBlocks. More...
class | LadderFilter
| Multi-mode filter based on the Moog ladder filter. More...
class | Limiter
| A simple limiter with standard threshold and release time controls, featuring two compressors and a hard clipper at 0 dB. More...
class | NoiseGate
| A simple noise gate with standard threshold, ratio, attack time and release time controls. More...
class | Oscillator
| Generates a signal based on a user-supplied function. More...
class | Phaser
| A 6 stage phaser that modulates first order all-pass filters to create sweeping notches in the magnitude frequency response. More...
class | Reverb
| Processor wrapper around juce::Reverb for easy integration into ProcessorChain. More...
struct | WaveShaper
| Applies waveshaping to audio samples as single samples or AudioBlocks. More...

## Typedefs

template<typename Type>
using | Complex = std::complex<Type>
template<size_t len, typename T>
using | FixedSizeFunction = juce::FixedSizeFunction<len, T>

## Enumerations

enum class | BallisticsFilterLevelCalculationType { peak , RMS }
enum class | DryWetMixingRule { linear , balanced , sin3dB , sin4p5dB , sin6dB , squareRoot3dB , squareRoot4p5dB }
enum class | FirstOrderTPTFilterType { lowpass , highpass , allpass }
enum class | LinkwitzRileyFilterType { lowpass , highpass , allpass }
enum class | PannerRule { linear , balanced , sin3dB , sin4p5dB , sin6dB , squareRoot3dB , squareRoot4p5dB }
enum class | StateVariableTPTFilterType { lowpass , bandpass , highpass }
enum class | LadderFilterMode { LPF12 , HPF12 , BPF12 , LPF24 , HPF24 , BPF24 }

## Functions

constexpr bool | operator== (const ProcessSpec &a, const ProcessSpec &b)
constexpr bool | operator!= (const ProcessSpec &a, const ProcessSpec &b)
template<int Index, typename... Processors>
auto & | get (ProcessorChain< Processors... > &chain) noexcept
| Non-member equivalent of ProcessorChain::get which avoids awkward member template syntax.
template<int Index, typename... Processors>
auto & | get (const ProcessorChain< Processors... > &chain) noexcept
| Non-member equivalent of ProcessorChain::get which avoids awkward member template syntax.
template<int Index, typename... Processors>
void | setBypassed (ProcessorChain< Processors... > &chain, bool bypassed) noexcept
| Non-member equivalent of ProcessorChain::setBypassed which avoids awkward member template syntax.
template<int Index, typename... Processors>
bool | isBypassed (const ProcessorChain< Processors... > &chain) noexcept
| Non-member equivalent of ProcessorChain::isBypassed which avoids awkward member template syntax.
template<typename Functor>
static WaveShaper< typename std::invoke_result< Functor >, Functor > | CreateWaveShaper (Functor functionToUse)

## Typedef Documentation

## Complex

template<typename Type>

using juce::dsp::Complex = std::complex<Type>

## FixedSizeFunction

template<size_t len, typename T>

using juce::dsp::FixedSizeFunction = juce::FixedSizeFunction<len, T>

## Enumeration Type Documentation

## BallisticsFilterLevelCalculationType

enum class juce::dsp::BallisticsFilterLevelCalculationType

strong

Enumerator
peak |
RMS |

## DryWetMixingRule

enum class juce::dsp::DryWetMixingRule

strong

Enumerator
linear |
balanced |
sin3dB |
sin4p5dB |
sin6dB |
squareRoot3dB |
squareRoot4p5dB |

## FirstOrderTPTFilterType

enum class juce::dsp::FirstOrderTPTFilterType

strong

Enumerator
lowpass |
highpass |
allpass |

## LinkwitzRileyFilterType

enum class juce::dsp::LinkwitzRileyFilterType

strong

Enumerator
lowpass |
highpass |
allpass |

## PannerRule

enum class juce::dsp::PannerRule

strong

Enumerator
linear |
balanced |
sin3dB |
sin4p5dB |
sin6dB |
squareRoot3dB |
squareRoot4p5dB |

## StateVariableTPTFilterType

enum class juce::dsp::StateVariableTPTFilterType

strong

Enumerator
lowpass |
bandpass |
highpass |

## LadderFilterMode

enum class juce::dsp::LadderFilterMode

strong

Enumerator
LPF12 |
HPF12 |
BPF12 |
LPF24 |
HPF24 |
BPF24 |

## Function Documentation

## operator==()

bool juce::dsp::operator== | ( | const ProcessSpec & | a,
|  | const ProcessSpec & | b )

constexpr

## operator!=()

bool juce::dsp::operator!= | ( | const ProcessSpec & | a,
|  | const ProcessSpec & | b )

constexpr

## get() [1/2]

template<int Index, typename... Processors>

auto & juce::dsp::get | ( | ProcessorChain< Processors... > & | chain | ) |

inline noexcept

Non-member equivalent of ProcessorChain::get which avoids awkward member template syntax.

References get().

Referenced by get(), and get().

## get() [2/2]

template<int Index, typename... Processors>

auto & juce::dsp::get | ( | const ProcessorChain< Processors... > & | chain | ) |

inline noexcept

Non-member equivalent of ProcessorChain::get which avoids awkward member template syntax.

References get().

## setBypassed()

template<int Index, typename... Processors>

void juce::dsp::setBypassed | ( | ProcessorChain< Processors... > & | chain,
|  | bool | bypassed )

inline noexcept

Non-member equivalent of ProcessorChain::setBypassed which avoids awkward member template syntax.

References setBypassed().

Referenced by setBypassed().

## isBypassed()

template<int Index, typename... Processors>

bool juce::dsp::isBypassed | ( | const ProcessorChain< Processors... > & | chain | ) |

inline noexcept

Non-member equivalent of ProcessorChain::isBypassed which avoids awkward member template syntax.

References isBypassed().

Referenced by juce::dsp::Convolution::getLatency(), isBypassed(), and juce::dsp::IIR::Filter< SampleType >::snapToZero().

## CreateWaveShaper()

template<typename Functor>

WaveShaper< typename std::invoke_result< Functor >, Functor > juce::dsp::CreateWaveShaper | ( | Functor | functionToUse | ) |

static

### Purchase

Get JUCE

### Discover

What's New in JUCE Features

### Learn

Documentaion Tutorials Made with JUCE Resources

### Support

JUCE Forum Newsletter Archive

### About

Contact Us JUCE Legal JUCE Licensing FAQ

### Events

Audio Developer Conference
© Raw Material Software Limited